﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PseudoInterpreter.Recursive
{
    public sealed class Result : ResultBase
    {
        internal override void SetDefault() { }
        public Result() { this.Dummy = false; }

        internal override void SetValue(object obj) { }
    }
    public sealed class Result<T> : ResultBase
    {
        public static Result<T> Create(T result) { return new Result<T>(result); }
        public Result(T result) { this.Dummy = false; this.value = result; }
        public Result() { this.Dummy = false; }

        private T value;
        public T Value { get { return value; } }

        internal override void SetDefault() { this.value = default(T); }

        public static implicit operator Result<T>(T result)
        {
            return new Result<T>(result);
        }
        public static implicit operator T(Result<T> result)
        {
            return result.value;
        }

        internal override object GetValue()
        {
            return value;
        }
        internal override void SetValue(object obj)
        {
            this.value = (T)obj;
        }
    }
}
