﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PseudoInterpreter.Ast
{
    public sealed class FunctionDeclaration : Statement
    {
        public Identifier Name;
        public List<Identifier> Parameters;
        public Statement Body;

        public FunctionDeclaration() : base(NodeType.FunctionDeclaration) {
            Parameters = new List<Identifier>();
        }
        public FunctionDeclaration(Identifier name, IEnumerable<Identifier> parameters, Statement body) : this() {
            this.Name = name;
            this.Parameters.AddRange(parameters);
            this.Body = body;
        }
    }
}
