﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Numerics;

namespace PseudoInterpreter.Interpreter
{
    public static class Constants
    {
        public static readonly Provider NaN = new SpecialConstantProvider(true, true);
        public static readonly Provider PositiveInfinity = new SpecialConstantProvider(false, true);
        public static readonly Provider NegativeInfinity = new SpecialConstantProvider(false, false);
        public static readonly IntegerConstantProvider One = new IntegerConstantProvider(BigInteger.One);
        public static readonly IntegerConstantProvider Zero = new IntegerConstantProvider(BigInteger.Zero);
        public static readonly Provider Nil = new NilConstantProvider();
#if TYPE_UNDEFINED
        public static readonly Provider Undefined = new UndefinedConstantProvider();
#endif
    }
}
