﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PseudoInterpreter.Recursive;

namespace PseudoInterpreter.Interpreter
{
    [System.ComponentModel.ImmutableObject(true)]
    public sealed class FunctionProvider : Provider, ICallProvider
    {
        public readonly MethodInfo MethodInfo;
        public FunctionProvider(MethodInfo minfo) {
            this.MethodInfo = minfo;
        }

        public override IEnumerable<Result<Provider>> Negate(AstInterpreter ai, ReferenceValue thisReference) { yield return Constants.Zero; }
        public override bool IsTrue(ReferenceValue thisReference) { return true; }


        #region ICallProvider
        public IEnumerable<Result<Provider>> Call(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue[] arguments)
        {
            Result<ReferenceValue> value = new Result<ReferenceValue>();
            yield return ai.Call<Provider, ReferenceValue>(ai.CallFunction(this.MethodInfo, arguments), value);
            yield return ((ReferenceValue)value).Provider;
        }
        #endregion
    }
}
