﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PseudoInterpreter.Recursive;

namespace PseudoInterpreter.Interpreter
{
    public interface IMathProvider
    {
        IEnumerable<Result<Provider>> Add(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Subtract(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Multiply(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Divide(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Remainder(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);

        IEnumerable<Result<Provider>> Increment(AstInterpreter ai, ReferenceValue thisReference);
        IEnumerable<Result<Provider>> Decrement(AstInterpreter ai, ReferenceValue thisReference);
        IEnumerable<Result<Provider>> Opposite(AstInterpreter ai, ReferenceValue thisReference);
        IEnumerable<Result<Provider>> Ceiling(AstInterpreter ai, ReferenceValue thisReference);
        IEnumerable<Result<Provider>> Floor(AstInterpreter ai, ReferenceValue thisReference);

    }
}
