﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PseudoInterpreter.Recursive;

namespace PseudoInterpreter.Interpreter
{
    public interface ISetProvider : IObjectProvider
    {
        IEnumerable<Result<bool>> Contains(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> SetDifference(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Intersect(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<Provider>> Union(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);
        IEnumerable<Result<int>> SetCompare(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv);

        IEnumerable<Result<IEnumerator<Provider>>> GetEnumerator(AstInterpreter ai, ReferenceValue thisReference);
    }
}
