﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PseudoInterpreter.Recursive;

namespace PseudoInterpreter.Interpreter
{
    [System.ComponentModel.ImmutableObject(true)]
    internal sealed class NilConstantProvider : Provider, IArrayProvider
    {
        public NilConstantProvider() { }

        #region Provider
        public override bool IsTrue(ReferenceValue thisReference) { return false; }
        public override IEnumerable<Result<Provider>> Negate(AstInterpreter ai, ReferenceValue thisReference) { yield return Constants.One; }
        #endregion

        #region IArrayProvider
        public ReferenceValue GetIndexedProperty(ReferenceValue thisReference, ReferenceValue rv)
        {
            ArrayProvider newProvider = new ArrayProvider();
            thisReference.SetValue(newProvider);
            return newProvider.GetIndexedProperty(thisReference, rv);
        }
        public ReferenceValue GetProperty(ReferenceValue thisReference, string name)
        {
            ObjectProvider newProvider = new ObjectProvider();
            thisReference.SetValue(newProvider);
            return newProvider.GetProperty(thisReference, name);
        }

        public IEnumerable<Result<Provider>> Slice(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue start, ReferenceValue end)
        {
            throw new InvalidOperationException();
        }
        #endregion
    }
}
