﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PseudoInterpreter.Recursive;

namespace PseudoInterpreter.Interpreter
{
    [System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never)]
    public abstract class Provider
    {
        protected const int INCOMPARABLE = 2;
        protected const int EQUAL = 0;
        protected const int LESS = -1;
        protected const int GREATER = 1;

        protected const int SUBSET = -1;
        protected const int SUPERSET = 1;

        public virtual IEnumerable<Result<int>> Compare(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue rv) {
            yield return (this == rv.Provider) ? EQUAL : INCOMPARABLE;
        }
        
        public virtual IEnumerable<Result<Provider>> Negate(AstInterpreter ai, ReferenceValue thisReference) { yield return IsTrue(thisReference) ? Constants.Zero : Constants.One; }
        public abstract bool IsTrue(ReferenceValue thisReference);
    }
}
