﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PseudoInterpreter.Interpreter
{
    internal sealed class RuntimeMethodInfo
    {
        public ReferenceValue Result;
        public Dictionary<string, ReferenceValue> Locals;

        public RuntimeMethodInfo(MethodInfo minfo, ReferenceValue[] Arguments)
        {
            Result = null;
            if (Arguments.Length != minfo.Parameters.Count) { throw new InvalidOperationException("Argument length mismatch"); }
            Locals = new Dictionary<string, ReferenceValue>();
            for (int i = 0; i < Arguments.Length; ++i)
            {
                Locals.Add(minfo.Parameters[i], Arguments[i]);
            }
            for (int i = 0; i < minfo.Locals.Count; ++i)
            {
#if TYPE_UNDEFINED
                Locals.Add(minfo.Locals[i], Constants.Undefined);
#else
                Locals.Add(minfo.Locals[i], Constants.Nil);
#endif
            }
        }
    }
}
