﻿#if TYPE_UNDEFINED
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PseudoInterpreter.Interpreter
{
    [System.ComponentModel.ImmutableObject(true)]
    internal sealed class UndefinedConstantProvider : Provider, IArrayProvider
    {
        public UndefinedConstantProvider() { }

        public override bool IsTrue(ReferenceValue thisReference) { return false; }
        public override IEnumerable<Recursive.Result<Provider>> Negate(AstInterpreter ai, ReferenceValue thisReference)
        {
            yield return Constants.One;
        }

        #region IArrayProvider
        public ReferenceValue GetIndexedProperty(ReferenceValue thisReference, ReferenceValue rv)
        {
            ArrayProvider newProvider = new ArrayProvider();
            thisReference.SetValue(newProvider);
            return newProvider.GetIndexedProperty(thisReference, rv);
        }
        public ReferenceValue GetProperty(ReferenceValue thisReference, string name)
        {
            ObjectProvider newProvider = new ObjectProvider();
            thisReference.SetValue(newProvider);
            return newProvider.GetProperty(thisReference, name);
        }

        public IEnumerable<Recursive.Result<Provider>> Slice(AstInterpreter ai, ReferenceValue thisReference, ReferenceValue start, ReferenceValue end)
        {
            throw new InvalidOperationException();
        }
        #endregion
    }
}
#endif