﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PseudoInterpreter.Tokenizer
{
    public class Token
    {
        public TokenType TokenType { get; private set; }
        internal Token(TokenType type) {
            this.TokenType = type;
        }
        public static implicit operator Token(TokenType type) {
            if (type == TokenType.ConstantDouble || type == TokenType.ConstantInteger || type == TokenType.Identifier) {
                throw new InvalidCastException("Cannot convert this tokenType");
            }
            return new Token(type);
        }
        public static explicit operator TokenType(Token token)
        {
            return token.TokenType;
        }
    }
}
